<?php

        
        include("robotUtil.inc");
        include("KCHtmlParse.inc");
        include("KCHttp.inc");
        include("KCFile.inc"); // ϱ
        include("KCString.inc");
        include("KCArray.inc");


        if($debug == "true")
        {
                define ("DEBUG_FLAG", true );
        }



//-----------------------------------------------------------
// url host path, ׸ ̸ иѴ.
//-----------------------------------------------------------
function getHostPath($url)
{
        //url ū ǥ  ǥ
        $url = str_replace("\"", "", $url);
        $url = str_replace("'", "", $url);

        $protocol = "http://";
        // ̷  url protocol ִ  տ ǥø 
        // absolute URL : schema : http
        //if( strstr($url, "http://") != "")

        //TODO: ⽺ host    иѴ.
        if( ereg("^$protocol", $url))
        {
                $url = substr($url, strlen($protocol));

                //host  ִ ˻Ѵ
                if(ereg("(/)", $url))
                {
                        list($host, $path) = split("/", $url, 2);
                        $path = "/$path";
                }
                else
                {
                        $host = $url ;
                        $path = "";
                }
        }
        // relative URI
        else
        {
                $host = "";
                $path = $url ;
        }

        //TODO: ⽺ host    иѴ.

        //ִٸ
        if(ereg("(/)", $path))
        {
                $cur_path = substr($path, 0, strrpos($path,"/")+1); //PATH ׻  "/"   Ѵ.
                $target_file = substr (strrchr ($path, "/"), 1 );
        }
        // $pathȿ '/' ٸ
        else
        {
                $cur_path = "";
                $target_file = $path ;
        }


        $url_data["host"] = $host ;
        $url_data["path"] = $cur_path ;
        $url_data["file"] = $target_file ;
        return $url_data ;
}

/*-----------------------------------------------------------
 1.  $url شϴ  http Ͽ html ҽ ´.
 2.   html  ̸ ϰ   
    Ѵ.
     ̸    ̸ default.html 
     Ѵ.
 3.  http log  ϰ   Ѵ

 4. Ľ̵   ȯѴ.
 5. http νϽ  нÿ false 
-----------------------------------------------------------*/
function Robot($url,$method)
{
        checkURL($url);



        $http = new KCHttp($url, $method);
        if($http == false)
        {
                echo $http->m_GetLastError();
                return false ;
        }

        echo "<br> $url ٿ ε <br>\n";
        if(defined("DEBUG_FLAG"))
        {
                $http->m_Debug = true ;
        }



        $http->m_InitHeader();

        //ϱ
        //$http->m_Connect();
        //Method,   ȭϸ
        //$http->m_Write("");
        //response ޾Ƽ   Ѵ.

        //Ÿ 
        $http->m_Fputs("");




        if($http->m_ReadHeader() == false)
        {
                echo $http->m_GetLastError();
                return false ;
        }


        $http->m_SendHeader();




        // 3xx    ٽ Header 

        //ȭ  ִ  ˻
        // 
        $local_file = "./data/".$http->m_GetAddress("domain") ; //  

        if(!strstr($http->m_GetTargetFile(), ".")) //Ȯ   
        {
                //----------------------------------------------------------------
                // Save Target File
                // KLUDGE : Target File   óϱ
                //        : http://www.geonji.co.kr  
                //        : http://www.geonji.co.kr/     Target file  Target directory
                //        : ֱ  $local_file "/" Ѵ.
                //
                //        :  ּ  丮   
                //        : http://www.geonji.co.kr/konlo or http://www.geonji.co.kr/konlo/
                //        : ̷  $local_file "/konlo/"  ȭϸ .
                //        :   ̸ 

                //----------------------------------------------------------------
                $c_local_file = new KCString($http->m_GetTargetFile());

                //  "/"   ƴϸ    ˻ϰ
                //  ̸  ̹Ƿ   "/default.html" ° ǵ Ѵ.
                if($c_local_file->m_Right(1) == "/")
                {
                        $c_local_file->m_Add("default.html");
                }
                else
                {
                        $c_local_file->m_Add("/default.html");
                }
                $local_file .= $c_local_file->m_GetString();
        }
        else
        {
                $local_file .= $http->m_GetTargetFile();
        }




        //echo "local_file $local_file ";
        $cFile = new KCFile ;
        $cFile->m_FOpen($local_file, "w") ;

        // ϱ
        //ϱ
        $cFile->m_Save($http->m_ReadBody());
        $cFile->m_Close();

        $http->m_Close();




        //----------------------------------------------------------------
        // Save Log
        //----------------------------------------------------------------
        $log_file = new KCFile ;
        $log_file->m_FOpen("./data/log/web_log.txt", "a");
        $log_file->m_Save("----- ".date("Y-m-d H:i", time())." ----- \n" );
        $log_file->m_Save("[Request Header] \n");
        $log_file->m_Save($http->m_GetRequestHeader()); // Request Header
        $log_file->m_Save("\n\n[Response Header] \n");
        $log_file->m_Save($http->m_GetResponseHeader()); // Response Header
        $log_file->m_Close();




        //  Content-type html ˻ϰ ׷ 츸 parsing ";
        if($http->m_GetHttpResponse("Content-Type") == "text/html")
        {

                $htmlParse = new KCHtmlParse ;
                //parsing ± 
                $htmlParse->m_SetParseTag("img,a");
                $html = $htmlParse->m_Parsehtml($http->m_GetResponseMessage());
        }
        else
        {
                $html = false ;
        }



        return $html ;
}

//-----------------------------------------------------------
// 1.   ִ URL ˻
// 2. ѹ 湮  ˻
// 3. 湮  ƴ ˻ϰ  url 
//-----------------------------------------------------------
function checkURL($url)
{
        global $cVisitUrl;

        if($url == "#")
        {
                return false ;
        }
        else
        {
                //URL  
                if(!$cVisitUrl->m_InArray($url))
                {
                        // url ϱ
                        $cVisitUrl->m_Add($url);
                        return true;
                }
                else
                {
                        return false ;
                }
        }
}


//-----------------------------------------------------------
// ȣƮ н ׸ н  full url .
//  path  path 踦 Ͽ full url  ش.
//-----------------------------------------------------------
function getFullUrl($host, $ori_path, $cur_path, $file)
{
        // TODO : $full_url 
        $full_url = "http://$host";

        // TODO : ori_path  cur_path ̿Ͽ full path .

        // link   :  path "/"  docroot Ѵٸ
        // ori_path   ٷ $cur_path $file full url .
        if(substr($cur_path,0,1) == "/")
        {
                $full_url = $full_url.$cur_path."$file";
        }
        // link   : cur_path  path ġ   
        // ori_path $cur_path  full н .
        else
        {
                //TODO : ori_path 
                //ori_path Ǿ    ori_path  docroot Ѵ.
                if($ori_path == "")
                {
                        $ori_path = "/";
                }
                else
                {

                }
                $full_url .= $ori_path ;


                //TODO: cur_path 
                //  丮 ǥ÷ "./XXX"· Ǿ   "./" 
                if(substr($cur_path,0,2) == "./")
                {
                        $cur_path = substr($cur_path,2) ;
                }
                // 丮  ƴϰ
                if($cur_path != "")
                {
                        $full_url .= $cur_path ;
                }


                //TODO: file 
                //file̸ "/" ƴ 쿡
                if( $file != "/")
                {
                        $full_url = "http://$host".$ori_path.$cur_path."$file";
                }
        }


        // TODO : $file  full path ʿ δ.
        return $full_url ;

}


//-----------------------------------------------------------
// $origin_host    : resource  host
// $down_load_list : ٿ ε  resource  ִ 
// $type           : ٿε  tag Ӽ
// $method         : HTTP method "POST" or "GET"
//-----------------------------------------------------------
function downLoad($ori_url_data, $down_load_list, $type, $method)
{
        //ٿ ε  tag Ӽ 
        switch(strtolower($type))
        {
                case "a" :
                        $tag_attr = "HREF";
                        break;
                case "img" :
                        $tag_attr = "SRC" ;
                        break;
        }


        // $down_load_list ŭ loop 鼭 resource ٿ ޴´.
        for($i = 0 ; $i < count($down_load_list) ; $i ++)
        {
                $url_count = $i + 1 ; //׳ ȭ   counter
                $target = $down_load_list[$i] ;

                //url host target file и
                //print_r($target[$tag_attr]);
                $cur_url_data = getHostPath($target[$tag_attr]);


                ///////////////////////////////
                if(defined("DEBUG_FLAG"))
                {
                        echo "<br><b>---------------------------------------------[".$url_count."/".count($down_load_list)."]</b><br>";
                        echo "cur_host " ;
                        print_r($cur_url_data);
                        echo "--><br>";
                }
                ///////////////////////////////



                //host  Ϳ host ֱ
                if($cur_url_data["host"] == "")
                {
                        $new_url = getFullUrl($ori_url_data["host"], $ori_url_data["path"], $cur_url_data["path"], $cur_url_data["file"]);
                }
                else
                {
                        $new_url = getFullUrl($cur_url_data["host"], $ori_url_data["path"], $cur_url_data["path"], $cur_url_data["file"]) ;
                        //Ʈ Ʈ    ܺ ũ  
                        if($origin_host != $cur_host)
                        {
                                //ܺ ũ 
                                //array_push($out_side_url, $cur_host.$cur_origin_path);
                        }
                }

                ///////////////////////////////
                if(defined("DEBUG_FLAG"))
                {
                        echo "url = ".$new_url." <br>\n";
                }
                ///////////////////////////////



                if(trim($target[$tag_attr]) != "")
                {
                        if(checkURL($new_url))
                        {
                                $url_data = getHostPath($new_url);
                                $cur_html = Robot($new_url, $method);


                                if($cur_html == false)
                                {
                                        continue ;
                                }
                                $url_saved = array_merge($url_saved, $cur_html["A"]);

                                //ο  ٿ ޱ
                                /*
                                downLoad($url_data , $cur_html["IMG"], "img", $method);
                                downLoad($url_data,  $cur_html["A"], "a", $method);
                                */
                        }
                }
                else
                {
                        echo "empty url <br>\n";
                }


                ///////////////////////////////
                if(defined("DEBUG_FLAG"))
                {
                        echo "<b>---------------------------------------------</b><br><br>";
                }
                ///////////////////////////////
        }
}

        $cVisitUrl = new KCArray ; //ѹ 湮 url 


        $start_time = time();
        // Target File down load

        startPage();
        require("url_form.html");
        echo "<a href='data/' target=new>Ÿ </a> <a href='data/log/web_log.txt'> α׺</a>";

        $url_data = getHostPath($url);
        $html = Robot($url,$method);  // Parsing   
        if($html == false)
        {
                echo "<br>Robot Error <br>\n";
                return false ;
        }


        //شϴ Target File Ե ̹ 
        downLoad($url_data , $html["IMG"], "img", $method);
        //  ũ ٿ ޱ

        exit;
        downLoad($url_data , $html["A"], "a", $method);
        $end_time = time();

        $webTime = $end_time - $start_time ;
        echo "<br> ð <font color=red> $webTime </font> <br>";

        endPage();
?>